package de.steev.bm.Listener;

import de.steev.bm.Manager.GameManager;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerBedEnterEvent;
import org.bukkit.event.player.PlayerBedLeaveEvent;

public class BedListener implements Listener {

    private GameManager gameManager;

    public BedListener(GameManager gameManager) {
        gameManager.getPlugin().getLogger().info("Bed Listener Registered");
        this.gameManager = gameManager;
    }

    @EventHandler // Adding to the Player Variable
    public void onPlayerBedEnter(PlayerBedEnterEvent event) {
        final World world = event.getPlayer().getWorld();
        if(world.getTime() >= 13000 || world.getThunderDuration() > 0 && this.gameManager.getConfigManager().GetBool("improved_bed")) {
            this.gameManager.getPlugin().playerInBed++;
            // Checks if enough Players (currentSleeping >= OnlinePlayerAmount/2) are Sleeping
            if(this.gameManager.getPlugin().playerInBed >= (int)this.gameManager.getPlugin().getServer().getOnlinePlayers().size()/2) {
                // Delayed Task for detecting useless entries
                Bukkit.getScheduler().scheduleSyncDelayedTask(this.gameManager.getPlugin(), new Runnable() {
                    @Override
                    public void run() {
                        if(gameManager.getPlugin().playerInBed >= (int)gameManager.getPlugin().getServer().getOnlinePlayers().size()/2) {
                            world.setTime(0);
                            world.setWeatherDuration(7 * 24000);
                        }
                    }
                }, 20L);
            }
        }
    }

    @EventHandler // Subtracting to the Player Variable
    public void onPlayerBedLeave(PlayerBedLeaveEvent event) {
        // Subtraction from the PlayerInBed variable
        if(this.gameManager.getPlugin().playerInBed > 0) {
            this.gameManager.getPlugin().playerInBed--;
            // Failsafe to prevent integer underflow
        }else if(this.gameManager.getPlugin().playerInBed > 0) {
            this.gameManager.getPlugin().playerInBed = 0;
        }
    }
}
